/*
    $Id: init.h,v 1.5 2002/05/24 05:51:59 belyi Exp $

    xkeysw - window bound/multi code keyboard switch
    Copyright (C) 1999  Dima Barsky, Igor Belyi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef XKEYSW_CONFIG_H
#define XKEYSW_CONFIG_H

#include "xwork.h"

/* Information about switching code is kept in this type of records */
struct codeRecord_t;

typedef struct switchKey_t {
    KeyCode switchCode;
    unsigned int modifiers;
    struct codeRecord_t* code;
} switchKey_t;

typedef struct codeRecord_t {
    char* prefix;
    keyMap_t keymap;
    int switchKeysSize;
    switchKey_t* switchKeys;
} codeRecord_t;

extern codeRecord_t* defaultCode;

int Initialize(char* filename);

#endif
